SEGMENT         BigSeg
ASSUME          CS:BigSeg


; Get info and write it to the screen
Proc    Init
        mov     ah,09h                  ; If this code is excecuted, then it
        mov     edx,Offset Str_Bull     ; must be a CPU in the computer :)
        int     21h
        mov     edx,Offset Str_Info     ; Write info to screen
        int     21h

        mov     ax,0EE00h               ; Get system information (DOS32)
        int     31h
        mov     al,dl                   ; AL = System type
        mov     edx,Offset _Table1
        cmp     al,1                    ; RAW?
        je      @@10
        mov     ebx,6                   ; Size of one line in table
        add     edx,ebx
        cmp     al,2                    ; XMS?
        je      @@10
        add     edx,ebx
        inc     ebx
        cmp     al,4                    ; VCPI
        je      @@10
        add     edx,ebx                 ; Must be DPMI
@@10:   mov     ah,09h
        int     21h

; Write program name +++

        ret
EndP    Init






Str_Bull        db      CR,LF,'CPU Detected, ',EOS
Str_Info        db      'System type: ',EOS
_Table1         db      'RAW',CR,LF,EOS
                db      'XMS',CR,LF,EOS
                db      'VCPI',CR,LF,EOS
                db      'DPMI',CR,LF,EOS

EndS            BigSeg



SEGMENT         U_DATA




EndS            U_DATA



;   *** Macros ***


; Print a debugging message to the screen
Macro   Say     Arg
LOCAL   L1,L2
IF      Debugging
        push    eax edx
        jmp     L2
L1:     db      CR,LF
        db      arg
        db      CR,LF,EOS
L2:     mov     ah,09h
        mov     edx,Offset L1
        int     21h
        pop     edx eax
ENDIF
EndM    Say


; Short delay between I/O to same device
Macro   IODELAY
        jmp     short $+2
        jmp     short $+2
EndM    IODELAY
